## 介绍
框的业务从单一的`searchbox`模块，发展到现在`xbox`、`po`等多个模块，每个模块都有自己的前端页面，所以需要一套统一的解决方案，我们称之为**Scorpion（天蝎）**（前端通用解决方案）， 放在`app/wise/boxfe/`下统一管理，其他模块通过`svn link`方式引入使用。

整个框前端解决方案详见《* [手机百度前端工程化介绍PPT](http://wangyongqing01.fe.baidu.com/webppt/box-fe-road.htm)》


目前天蝎的 `Bdbox` 已经完成18+大类，50+个功能和交互模块，覆盖手机百度90%以上的功能，平均代码注释率在40%以上，部分模块代码注释率在60%以上，甚至注释超过代码！


 * [Box](./global.html#Box)：是框的业务层命名空间，提供命名空间管理方法和init（domready）入口，[详细介绍](http://fe.baidu.com/doc/kuang/searchbox/fis/Box_framework.text)
 * [Bdbox](./Bdbox.html)：是框的前端组件库，提供常用组件，[详细介绍](http://fe.baidu.com/doc/kuang/searchbox/fis/Bdbox_framework.text.text)
 * [S](./S.html)：是框webspeed速度打点监控代码，来自`search模块`，[详细介绍](http://fe.baidu.com/doc/kuang/search/search_speed_log.text)
 * 其他：Roulette、Scrape之类是`bdbox/game`中的一些前端抽奖小游戏的构造类，主要是`po`模块、运营活动用，另外`bdbox/game/base`文件夹下是做html5 canvas游戏常用的类，没有导出到该文档中
 * 调起分发库：Bdbox.Openapp[文档地址](http://fe.baidu.com/doc/kuang/searchbox/invoke.text)
 * 运营活动基础库：openjs，[文档地址](http://cms.m.baidu.com/wiki/fe/README.html)

## 主要模块表格

模块分类    | 包含模块      | 功能说明
:--------  | :----------- | :------------------
业务类  | [Bdbox.ios](Bdbox.ios.html)\ [Bdbox.android](Bdbox.android.html)\ [Bdbox.moplus](Bdbox.moplus.html)\ [Bdbox.apad](Bdbox.apad.html)\ [Bdbox.lbs](Bdbox.lbs.html)\ [Bdbox.invoke](Bdbox.html#invoke)\ [Bdbox.client](Bdbox.client.html)  | 跟业务相关，例如安卓和ios的invokeApp，moplus，调起（**非百度域名也可以**）和定位等
工具类    | [Bdbox.utils](Bdbox.utils.html)\ [Bdbox.is*](Bdbox.html#isString)\ [Bdbox.getId](Bdbox.html#getId)\ [Bdbox.$](Bdbox.html#$) | 工具类相关函数，例如获取版本号，浏览器类型判断等
模板类    | [Bdbox.template](Bdbox.html#template)\ [Bdbox.utils.template](Bdbox.utils.html#template)\ [Bdbox.artTemplate](Bdbox.artTemplate.html) | 跟模板和components相关的类
监控和用户行为 | [Bdbox.monitor](Bdbox.monitor.html)\ [S](S.html) | 包含速度监控、百度统计、行为监控、域名劫持、特性嗅探、js报错等
通信类    | [Bdbox.io](Bdbox.io.html) | 包括无依赖的`ajax`，`loadjs`，加载combo和**跨域通信**等
事件类    | [Bdbox.event](Bdbox.event.html) | 广播事件、无依赖事件代理、事件发射器、fastclick和**跨域消息**
webapp相关 | [Bdbox.app](Bdbox.app.html) | 包括cache实现（可按照时间）、路由、观察者封装
UI相关 | [Bdbox.ui](Bdbox.ui.html) | 跟具体UI相关的，例如弹层、蒙版、幻灯片切换
运营活动 | [Bdbox.weixin](Bdbox.weixin.html)和抽奖游戏 | 微信分享等和Roulette、Scrape之类是`bdbox/game`中的一些前端抽奖小游戏的构造类
Zepto扩展 | lazyload，paper等 | zepto的扩展
localstorage相关 | [Bdbox.ls](Bdbox.ls.html) | 主要用于细粒度缓存，一般不单独使用
其他 | [Bdbox.Deferred](Bdbox.html#Deferred)/[Bdbox.require](Bdbox.html#template)/[Bdbox.define](Bdbox.html#define) | promise实现，异步编程，模块注册定义等



## demo
  在common中执行`fisp release -d output` 然后访问demo文件夹中的相关测试demo

## common模块

 * 框前端统一解决方案，目前解决方案：
    * [localstorage细粒度缓存](http://fe.baidu.com/doc/kuang/fe/common-localstorage-cache.text)
    * [AMD模块化规范](http://fe.baidu.com/doc/kuang/searchbox/fis/Bdbox_framework.text)
    * [require语法内嵌](http://fe.baidu.com/doc/kuang/searchbox/fis/fis-require.text)
    * 渲染模式支持：inline/combo/tag
    * 抽样
    * 根据网络速度和类型前端自动适配方案
 * 存放基础库、业务公共代码
 * 提供 smarty 插件
 * 父子模板拆分为解决方案提供了很好的前提

## tpl目录结构

此目录结构作为各个模块的目录结构标准：

```bash
 TPL
  ├─demo # demo示例目录，不上线
  ├─docs # 文档目录，不上线
  ├─layout # 父模板目录，建议一个action对应一个父模板目录
  ├─page # 子模板目录，继承自父模板，根据具体业务分子目录
  │  └─xxx # 子模板的子目录，比如小说定为novel
  ├─static # 静态资源
  │  ├─css
  │  ├─img
  │  └─js
  ├─test # 放fis的调试json文件，用于本地开发，不上线
  │  └─page
  │      └─xxx
  ├─widget # widget目录
  └─nodejsLib # nodejs工具
```

## Todolist

 * 监控：速度、js报错收集
 * 摸底客户端各webview实现差异
 * 添加jshint和csslint语法和代码规范检测
 * [localstorage cookie 根据path多维度缓存](http://fe.baidu.com/doc/kuang/fe/common-localstorage-cache.text)
 * [代码部署流程改造（本机对本机）](http://fe.baidu.com/doc/kuang/fe/%E6%A8%A1%E6%9D%BF%E9%83%A8%E7%BD%B2%E5%B7%A5%E5%85%B7.text)
 * 静态资源cdn+combo解决方案
 * 结合后端php做抽样和模板组件化
 * 推动UI设计标准、icon统一、交互统一
 * Sass的推广
 * 根据机型降级


## 更多
 * [手机百度前端工程化介绍PPT](http://wangyongqing01.fe.baidu.com/webppt/box-fe-road.htm)
 * [框文档平台](http://fe.baidu.com/doc/kuang/)
 * [框前端文档平台](http://fe.baidu.com/doc/kuang/fe)
 * [框FIS相关文档](http://fe.baidu.com/doc/kuang/searchbox/fis)
 * [常见javascript编码问题和注意点](http://fe.baidu.com/doc/kuang/tech/front/fe-code-style.text)
 * [手机百度前端工程化之路](http://mweb.baidu.com/p/baidusearch-front-end-road.html)
 * [前端common模块localstorage使用指南](http://fe.baidu.com/doc/kuang/fe/common-localstorage-cache.text)

## 怎么写好注释
 * [jsdoc文档](http://usejsdoc.org/#JSDoc3_Tag_Dictionary)
 * 开发工具安装jsdoc插件，例如sublime的docblockr


